/***********************************************************************************************************************
 *
 * blueBill Stats
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile/
 * SCM: http://java.net/hg/bluebill-server~stats-src
 *
 **********************************************************************************************************************/
package it.tidalwave.role.spi;

import javax.annotation.Nonnull;
import it.tidalwave.util.Id;
import it.tidalwave.role.IdFactory;
import com.eaio.uuid.UUID;

/***********************************************************************************************************************
 *
 * An implementation of {@link IdFactory} that uses UUIDs.
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class UuidIdFactory implements IdFactory // TODO: move class to TFT
  {
    /** {@inheritDoc} */
    @Override @Nonnull
    public synchronized Id createId() 
      {
        return new Id(new UUID().toString());
      }

    /** {@inheritDoc} */
    @Override @Nonnull
    public Id createId (final @Nonnull Class<?> objectClass)
      {
        return createId();
      }

    /** {@inheritDoc} */
    @Override @Nonnull
    public Id createId (final @Nonnull Class<?> objectClass, final @Nonnull Object object) 
      {
        return createId();
      }
  }
